\documentclass[12pt,a4paper]{article}
\usepackage{amsmath,amssymb,amsthm,epsfig,amscd,verbatim}
\usepackage[french]{babel} 
\usepackage{fancyvrb}
%\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\addtolength{\textwidth}{3cm} 
\addtolength{\textheight}{4cm}
\addtolength{\hoffset}{-2cm} 
\addtolength{\voffset}{-2cm}

\usepackage{hyperref}
\usepackage{float}
\usepackage{algorithm}
\usepackage{algorithmic}
\renewcommand{\algorithmicrequire}{\textbf{Input:}}
\renewcommand{\algorithmicensure}{\textbf{Output:}}

%% commandes utiles %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\newcommand{\R}{\mathbb{R}}
\newcommand{\C}{\mathbb{C}}
\renewcommand{\vec}[1]{\mathbf{#1}}
\newcommand{\tr}{\mbox{tr}}
\newcommand{\Span}{\mbox{span}}
\DeclareMathOperator*{\argmin}{arg\,min}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\begin{document}
\noindent UNIVERSIT\'E DE GEN\`EVE \hfill Section de Math\'ematiques \\
\noindent Facult\'e des Sciences \hfill \`A rendre le mercredi 18 mai \\[-3mm] \hrule
\bigskip

\begin{center}
\textbf{\Large{Méthodes Itératives}}  \\[1mm]\bigskip
\textbf{Série 5}
\end{center}
\bigskip

\textbf{Exercise 1: Conjugate Gradient method.} (4 pts)\\
Consider the following conjugate gradient algorithm for the solution of $A \vec{u} = \vec{f}$.
\begin{algorithm}\caption{(Conjugate gradient algorithm)}
\begin{algorithmic}[1]
	\REQUIRE Initial approximation $\vec{u}_0$, maximum number of iterations $k_{max}$, tolerance $tol$;
	\ENSURE Approximate solution $\vec{u}_k$;
	\STATE $\vec{r}_0 = \vec{f} - A \vec{u}_0$;
	\STATE $\vec{p}_0 =\vec{r}_0$ and $k=0$;
	\WHILE{$k < k_{max}$ \AND $\|\vec{r}_k\|_2 > tol$}
		\STATE  $\alpha_k = \frac{ \vec{r}_k^\top \vec{p}_k }{ \vec{p}_k^\top A \vec{p}_k }$;
		\STATE  $\vec{u}_{k+1} = \vec{u}_{k} + \alpha_k \vec{p}_{k}$;
		\STATE  $\vec{r}_{k+1} = \vec{f} - A \vec{u}_{k+1}$;
		\STATE  $\beta_k = \frac{ \vec{r}_{k+1}^\top A \vec{p}_k}{\vec{p}_{k}^\top A \vec{p}_k }$;
		\STATE  $\vec{p}_{k+1} = \vec{r}_{k+1} + \beta_k \vec{p}_{k}$;
		\STATE  $k = k + 1$;
	\ENDWHILE
	\RETURN $\vec{u}_k$;
\end{algorithmic}
\end{algorithm}
Notice that in the ``while'' loop there are 4 matrix-vector multiplications.
Rewrite the algorithm is such a way that only one matrix-vector multiplication is used
in the loop. Try also to reduce the number of vector-vector multiplications.\\
\underline{Hint :} show that $\alpha_k = \frac{ \|\vec{r}_k\|_2^2}{ \vec{p}_k^\top A \vec{p}_k }$
and $\beta_k = \frac{ \|\vec{r}_{k+1}\|_2^2}{ \|\vec{r}_{k}\|_2^2 }$.

\bigskip
\textbf{Exercise 2: Optimality of the step-length.} $\,$ (3 pts)
\begin{itemize}
\item Show that the step-length $\alpha_k = \frac{ \vec{r}_k^\top \vec{p}_k }{ \vec{p}_k^\top A \vec{p}_k }$
is optimal in the sense that it minimizes the function
$\alpha \mapsto \phi(\alpha) := \frac{1}{2} (\vec{u}_k + \alpha \vec{p}_k )^\top A (\vec{u}_k + \alpha \vec{p}_k )
- \vec{f}^\top (\vec{u}_k + \alpha \vec{p}_k )$.
\item Show that $\alpha_k$ minimizes $\alpha \mapsto \varphi(\alpha) \| \vec{u}_k + \alpha \vec{p}_k - \vec{u} \|_A^2$.
\end{itemize}

\bigskip
\textbf{Exercise 3: Lanczos and Conjugate Gradient methods.}\\
In this exercise you will derive the conjugate gradient method, for the solution
of $A \vec{u} = \vec{f}$ ($A\in \mathbb{R}^{n \times n}$  symmetric positive definite), from the Lanczos method.
To do so, consider the following steps.
\begin{enumerate}\itemsep0em
\item (3 pts) Recall the decomposition $AQ_k = Q_{k+1} H_k$, where
$Q_k = \begin{bmatrix} \vec{q}_1 & \cdots & \vec{q}_k \end{bmatrix} \in \mathbb{R}^{n \times k}$
and assume that $\vec{q}_1 = \frac{1}{\|\vec{f}\|_2} \vec{f}$.
The matrix $H_k$ has the form
$H_k = \begin{bmatrix}
T_k \\
\vec{v} \\
\end{bmatrix}$
where
\begin{equation*}
T_k = \begin{bmatrix}
\alpha_1 & \beta_1 \\
\beta_1 & \alpha_2 & \beta_2 \\
& & \ddots \\
& & & \beta_{k-1} & \alpha_k \\
\end{bmatrix},
\end{equation*}
and $\vec{v} = \begin{bmatrix}
0 & \cdots & 0 & \beta_k
\end{bmatrix}$.
\begin{itemize}\itemsep0em
\item[a)] Show that $Q_k^\top A Q_k = T_k$.
\item[b)] Show that 
\begin{equation*}
\vec{u}_k := \argmin_{\vec{u}_k \in \Span\{ \vec{q}_1 \, \cdots \, \vec{q}_k \}} \frac{1}{2} \vec{u}_k^\top A \vec{u}_k-\vec{u}_k^\top \vec{f} = Q_k T_k^{-1} \bigl( \| \vec{f}\|_2 \vec{e}_1 \bigr) . 
\end{equation*}
\underline{Hint:} Introduce a vector $y \in \mathbb{R}^k$ such that $x_k = Q_k y$ and prove that $y = T_k^{-1} Q_k^\top \vec{f}$.
\end{itemize}

\item (3 pts) Consider the $LU$-decomposition of $T_k$, that is $T_k = L_k U_k$, where
\begin{equation*}
L_k = \begin{bmatrix}
1 \\
\gamma_1 & 1 \\
& & \ddots \\
& & & \gamma_{k-1} & 1 \\
\end{bmatrix}
\quad \text{and} \quad
U_k = \begin{bmatrix}
\eta_1 & \beta_1 \\
& \eta_2 & \beta_2 \\
& & \ddots \\
& & & & \eta_k \\
\end{bmatrix}.
\end{equation*}
\begin{itemize}\itemsep0em
\item[a)] Show that $\gamma_{k-1} = \frac{\beta_{k-1}}{\eta_{k-1}}$ and $\eta_k = \alpha_k - \gamma_{k-1} \beta_{k-1}$.
\item[b)] Define $P_k := Q_k U_k^{-1}$ and show that the columns $\vec{p}_j$ of $P_k$ satisfy
$\vec{p}_j = \frac{1}{\eta_j}\bigl( \vec{q}_j - \beta_{j-1} \vec{p}_{j-1} \bigr)$ for $j=1,\dots,k-1$ and
$\vec{p}_k = \frac{1}{\eta_k} \vec{q}_k$.
\item[c)] Show that $\vec{u}_k = \vec{u}_{k-1} + \zeta_k \vec{p}_k$ for a $\zeta_k \in \mathbb{R}$.
\underline{Hint:} begin with $\vec{u}_k = Q_k T_k^{-1} \bigl( \| \vec{f}\|_2 \vec{e}_1 \bigr)$
and use the LU-decomposition of $T_k$.
\end{itemize}

\item (4 pts) Prove that:
\begin{itemize}\itemsep0em
\item the vectors $\vec{p}_k$ are $A$-orthogonal.
\item $\vec{r}_k = \sigma_k \vec{q}_{k+1}$ for some $\sigma_k \in \mathbb{R}$,
where $\vec{r}_k = \vec{f} - A \vec{u_k}$ is the residual.
\item $\vec{r}_k \perp \vec{q}_j$ for $j=1,\dots,k-1$ and that $\vec{r}_k \perp \vec{r}_{k-1}$
\end{itemize}

\item (3 pts) Take a vector $\tilde{\vec{p}}_{k-1}$ parallel to $\vec{p}_{k}$, then we can rewrite 
$\vec{u}_k = \vec{u}_{k-1} + \zeta_k \vec{p}_k$ (2.c) as $\vec{u}_k = \vec{u}_{k-1} + \tilde{\alpha}_{k-1} \tilde{\vec{p}}_{k-1}$ 
for some $\alpha_{k-1}$.
\begin{itemize}\itemsep0em
\item Show that $\tilde{\vec{p}}_{k} = \vec{r}_{k} + \tilde{\beta}_{k} \tilde{\vec{p}}_{k-1}$
for some $\tilde{\beta}_{k} \in \mathbb{R}$.
\item Compute $\tilde{\alpha}_k$ by using the orthogonality $\vec{r}_k \perp \vec{r}_{k-1}$.
\item Compute $\tilde{\beta}_k$ by using the $A$-orthogonality of the vectors $\tilde{p}_k$.
\underline{Hint:} you should obtain that $\tilde{\alpha}_k = \frac{ \| \vec{r}_k \|_2^2 }{ \tilde{\vec{p}}_k^\top A  \tilde{\vec{p}}_k}$ and $\tilde{\beta}_k = \frac{ \| \vec{r}_k \|_2^2 }{ \| \vec{r}_{k-1} \|_2^2 }$.
\end{itemize}

\item (1 pts) Summarize the obtained results and compare them with the algorithms in Exercise 1.

\end{enumerate}


\bigskip
\textbf{Exercise 4: Krylov space.} (extra pts 6)\\
Consider the vectors $\vec{r}_j$ and $\vec{p}_j$ for $j=1,\dots,k$ generated by the
conjugate gradient iterations till the $k$th iterate. We have
\begin{equation*}
\Span \{ \vec{r}_0 , \dots, \vec{r}_k \} = {\cal K}_k(A,\vec{r}_0)
\quad \text{and} \quad
\Span \{ \vec{p}_0 , \dots, \vec{p}_k \} = {\cal K}_k(A,\vec{r}_0).
\end{equation*}

\bigskip
{\bf \'Evaluation:}
\begin{itemize}
\item[$\bullet$] Les exercices
\item[$\bullet$] Un examen oral durant la session d'examens sur le cours.
\end{itemize}
La note finale est de : $30 \%$ exercices et $70\%$ examen oral.\\ 
Les exercices sont notés $15\%$ pour la présentation de séries et
$15\%$ pour la présentation au tableau. Il faut passer au tableau au
moins 3 fois dans le semestre.
 

\end{document}
